<?xml version="1.0" encoding="utf-8" standalone="yes"?>
<table_data>
<!-- #include file="common.asp" -->
<!-- #include file="xl_session_check.asp" -->
<%
'//-------------------------------------------------------------------------//
'// データ
'//-------------------------------------------------------------------------//
If session_check = "OK" Then

    response_ok = "NG"

    '// 日付時刻(YYYYMMDDHHMISSFFF)
    date_time = Date & Right("0" & Time, 8) & Right("000" & Round(Timer - Fix(Timer), 3) * 1000, 3)
    date_time = Replace(date_time, "/", "")
    date_time = Replace(date_time, "-", "")
    date_time = Replace(date_time, ":", "")
    date_time = Replace(date_time, ".", "")

    '// ファイルID
    file_id = "D" & date_time & "_" & host_cd & "_" & Session.SessionID
    xml_path = Server.MapPath("./xml/" & file_id & ".xml")

    '// 暗号キー（データベース用）
    key = key_db()
    iv  = Left(key, 32)

    '//------------------------------------------------------------//
    '// 接続情報
    '//------------------------------------------------------------//

    '// Open
    user_table.Open Server.MapPath(repository_conn & "DXT_USER.xml")
    data_table.Open Server.MapPath(repository_conn & "DXT_DATA.xml")
    udat_table.Open Server.MapPath(repository_conn & "DXT_UDAT.xml")
    odbc_table.Open Server.MapPath(repository_conn & "DXT_ODBC.xml")

    '// Filter
    user_table.Filter = "USER_CD = '" & user_cd & "'"
    data_table.Filter = "DATA_CD = '" & data_cd & "'"
    udat_table.Filter = "USER_NAME = '" & user_table("USER_NAME") & "' AND DATA_ID = '" & data_table("DATA_ID") & "'"
    odbc_table.Filter = "ODBC_NAME = '" & data_table("ODBC_NAME") & "' AND ODBC_USER = '" & data_table("ODBC_USER") & "'"

    If Not (user_table.EOF Or data_table.EOF Or odbc_table.EOF) Then

        '// 1:管理者／2:非管理者
        If user_table("ADMIN_CLS") = "1" Then
            response_ok = "OK"
        Else
            If Not udat_table.EOF Then response_ok = "OK"
        End If

        '// Fields.Value
        odbc_name = data_table("ODBC_NAME")
        odbc_user = data_table("ODBC_USER")
        odbc_pass = decrypt(odbc_table("ODBC_PASS"), iv, key)
        sql_text  = data_table("SQL_TEXT")
        page_size = data_table("PAGE_SIZE")

    End If

    '// Close
    user_table.Close
    data_table.Close
    udat_table.Close
    odbc_table.Close

    '//------------------------------------------------------------//
    '// データ取得 → ファイル保存
    '//------------------------------------------------------------//

    If response_ok = "OK" Then

        '// Open
        connection_string = "Provider=MSDASQL;Data Source=" & odbc_name & ";User ID=" & odbc_user & ";Password=" & odbc_pass & ";"
        objADO.Open connection_string
        objADO.CommandTimeout = 0

        file_no = 0

        '// RowsetSchema ファイル作成
        If page_size = 0 Then
            '// 一括ファイル保存
            Set objRS = objADO.Execute(sql_text)
            objRS.Save xml_path, adPersistXML
        Else
            '// ファイル保存（テーブル定義）
            Set objRS = CreateObject("ADODB.Recordset")
            objRS.MaxRecords = 1
            objRS.Open sql_text, connection_string, adOpenStatic, adLockReadOnly, adCmdText
            objRS.Filter = "[" & objRS.Fields(0).Name & "] <> '" & objRS.Fields(0).Value & "'"
            objRS.Save xml_path, adPersistXML
            objRS.Close

            '// Execute SQL
            Set objRS = objADO.Execute(sql_text)

            ReDim FieldList(objRS.Fields.Count - 1)
            ReDim Values(objRS.Fields.Count - 1)

            '// Fields.Name
            n = 0
            For Each objField In objRS.Fields
                FieldList(n) = objField.Name
                n = n + 1
            Next

            '// Recordset → ファイル分割
            Do Until objRS.EOF

                objData.Open xml_path, , adOpenKeyset, adLockOptimistic

                For row_no = 1 To page_size
                    '// GetRows → ２次元配列
                    aryRows = objRS.GetRows(1, adBookmarkCurrent)
                    '// ２次元配列 → １次元配列
                    For col_no = 0 To UBound(aryRows, 1)
                        Values(col_no) = aryRows(col_no, 0)
                    Next
                    '// レコード追加
                    objData.AddNew FieldList, Values
                    '// 終了
                    If objRS.EOF Then Exit For
                Next

                '// 分割ファイル保存
                file_no = file_no + 1
                xml_data = Server.MapPath("./xml/" & file_id & "_" & file_no & ".xml")
                objData.Save xml_data, adPersistXML
                objData.Close

            Loop

        End If

        '// Close
        objADO.Close

        If fso.FileExists(xml_path) Then
            Response.Write "<file_ckeck>OK</file_ckeck>"
            Response.Write "<file_id>" & file_id & "</file_id>"
            Response.Write "<file_no>" & file_no & "</file_no>"
        Else
            Response.Write "<file_ckeck>NG</file_ckeck>"
        End If

    Else
        Response.Write "<file_ckeck>NG</file_ckeck>"
    End If

End If
%>
</table_data>
