<!DOCTYPE html>
<html lang="ja">
<!-- #include file="page_head.asp" -->
<!-- #include file="common.asp" -->
<!-- #include file="login_check.asp" -->
<%
'// 変数定義 -------------------------------------------------------------------
err_msg     = ""
x_user_name = Request("x_user_name")
x_data_id   = Request("x_data_id")
x_comments  = Request("x_comments")

If mode = "insert" Then

    '// user_name
    x_user_name = get_user_name(hex_encode(UCase(x_user_name)))
    If x_user_name = "" Then
        x_user_name = Request("x_user_name")
        err_msg = err_msg & "・ユーザー名が登録されていません。<br>"
    End If

    '// data_id
    x_data_id = get_data_id(hex_encode(UCase(x_data_id)))
    If x_data_id = "" Then
        x_data_id = Request("x_data_id")
        err_msg = err_msg & "・データIDが登録されていません。<br>"
    End If

    If err_msg = "" Then
        '// Open
        udat_table.Open Server.MapPath(repository_conn & "DXT_UDAT.xml")
        '// Filter
        udat_table.Filter = "USER_NAME = '" & x_user_name & "' AND DATA_ID = '" & x_data_id & "'"
        '// Result
        If Not udat_table.EOF Then
            err_msg = "・同じデータIDが既に登録されています。"
        End If
        '// Close
        udat_table.Close
    End If

    If err_msg = "" Then
        '// Open
        udat_table.Open Server.MapPath(repository_conn & "DXT_UDAT.xml"), , adOpenKeyset, adLockOptimistic
        '// Array
        ReDim FieldList(udat_table.Fields.Count - 1)
        ReDim Values(udat_table.Fields.Count - 1)
        '// Fields.Name
        For n = 0 To udat_table.Fields.Count - 1
            FieldList(n) = udat_table.Fields(n).Name
        Next
        '// Values (REC_DATE, REC_USER, USER_NAME, DATA_ID, COMMENTS)
        Values(0) = Date & " " & Time
        Values(1) = Session.Contents("user_name")
        Values(2) = x_user_name
        Values(3) = x_data_id
        Values(4) = x_comments
        '// レコード追加
        udat_table.AddNew FieldList, Values
        '// Filter
        udat_table.Filter = ""
        '// 保存
        udat_table.Save , adPersistXML
        '// Result
        If Err Then
            err_msg = "[ERROR] " & Err.Number & ":" & Err.Description
        End If
        '// Close
        udat_table.Close
    End If

    If err_msg = "" Then
        x_user_name = ""
        x_data_id   = ""
        x_comments  = ""
        Response.Redirect "menu_udat.asp"
    End If

End If
%>
<body>
<!-- #include file="page_title.asp" -->
<!-- #include file="page_menu.asp" -->
<form name="form1" method="post" class="menu_udat">
<div class="wrapper">
    <!-- #include file="page_hidden.asp" -->
    <div class="name">ユーザー名</div>
    <div class="form"><input type="text" name="x_user_name" value="<%=x_user_name%>" list="i_user_name" autofocus></div>
    <div class="name">データID</div>
    <div class="form"><input type="text" name="x_data_id" value="<%=x_data_id%>" list="i_data_id"></div>
    <div class="name">コメント</div>
    <div class="form"><input type="text" name="x_comments" value="<%=x_comments%>"></div>
    <input type="button" class="add_btn" value="登録" onclick="udat_insert();">
    <!-- エラー・メッセージ -->
    <p id="err"><%=err_msg%></p>
</div>
</form>
<!-- #include file="datalist_user_name.asp" -->
<!-- #include file="datalist_data_id.asp" -->
<script src="menu_udat_add.js"></script>
</body>
</html>
